Migrate wikis to use a single edit tab which has both visual and wikitext modes and allows on-the-fly switching between them
Open, HighPublic8 Story Points

Tokens
"Mountain of Wealth" token, awarded by matej_suchanek."Dislike" token, awarded by DC."Dislike" token, awarded by Steinsplitter."Dislike" token, awarded by Base."Love" token, awarded by AdHuikeshoven."Doubloon" token, awarded by RandomDSdevel."Like" token, awarded by APerson."Haypence" token, awarded by Mvolz."Dislike" token, awarded by Ricordisamoa."Love" token, awarded by Schnark.
Assigned To
None
Authored By
Neil_P._Quinn_WMF, Jun 14 2015

Description

For details on operation, please see T114530: Change VE integration to only use one edit tab.


Steps for switching.

  • Add button to the WikiEditor and VisualEditor toolbars for switching back and forth mid-edit – T49779, blocked by T104663
  • Change the VE-MW integration to not add a new tab, make it look like the "Edit" tab is active; on page load, re-write the URL of the "edit" button to go to VE or WE based on users' last choice (site default applies if no pref, or for anons, no cookie) – T114530
  • Intercept all calls to action=edit (undo, diffs, etc.) to apply consistently for user expectation – T114531
  • For wikis where VE isn't the default choice, on an IP's edit-click, set a cookie of a random number, and allow direction to WE or VE based on some threshold (so ramped-up change is possible) – T128484
  • For such wikis, slowly increase the switchover with testing to ensure it's not disruptive – X.

Related Objects

There are a very large number of changes, so older changes are hidden. Show Older Changes

As we are not changing anyone's editor, and we already have a splash screen on VE for new users I think we can just provide a tooltip showing them where the wikitext editor button is. Forcing the user to make a choice when you don't know if they are informed enough yet to make that choice could lead to confusion. The tooltip should be prominent enough for people who were expecting WT editor to see it, but easy enough to ignore/dismiss for people who aren't interested.

True.
May be displayed once to people who already edit. By this way, they will be informed on the single edit tab, and not surprised by the disappearance of one tab.

I am also concerned that due to the progress we have made getting established WT users to try out VE, that we now have a significant number of users who choose "edit" or "edit source" in advance depending on the task at hand.

I'm one of them, and I think I may be upset sometimes if I have to load a page on VE to perform wikitext changes. As Erica suggest, that may be fixed by a gadget that offers the two tabs.
This still ask the question : is it really relevant to have a single edit table? Sorry, but I'm not convinced.

In my last 50 edits in mainspace, I used VE 22 times. For some things (doing a citation, using citiod, for example), VE is clearly superior to the wikieditor. But VE can't do some things (or, at least, I can't figure out how to do them using VE); for other things (cleaning up a ref=name problem) wikitext editing is better. What I like, now, is that with one click, I can be in the editor of my choice. So it's not clear to me what problem is being solved by a single edit tab. [Q: Would there also just be one selection to the right of each section heading, rather than - as at present - two?]

I suppose if I were forced to make a choice, assuming there is going to be only one edit tab, I'd vote for "use last edit mode" as the default, rather than setting my preference to always open editing in one or the other. Regardless, I'd be irritated that if I opened in VE but wanted the wikitext editor, I'd be two clicks from that. (Someone who couldn't remember how to switch to the wikitext editor would be even more irritated.) And that, of course, assumes I'd not started editing a page that VE is slow to open.

It also seems to me much more likely that with a single tab, a new user editing Wikipedia is going to be unaware that there are two different editing interfaces. Sure, there could be a message (easier in VE than in wikitext) saying something like "Look in your preferences if you want to change editors; also, here's how to switch if you want to change to the other", but really, most newbies are - I'd argue - just trying to keep their head above water, not trying figure out all the options. Similarly, there could be a dropdown arrow, as suggested, but either there is one menu choice (odd) or there are two (so, the user now has an extra step); neither of these are better than the present system, I think.

What I like about the current two-tab approach, besides ease of use, is that it encourages new users - at some point - to try both editing interfaces. To that end, it would be nice if the tooltips for the two tabs used the terms "VisualEditor" and "wikitext editor".

What I like, now, is that with one click, I can be in the editor of my choice. So it's not clear to me what problem is being solved by a single edit tab.

Exactly. The proposed design would actually require more thought without even coming close to decreasing interface clutter.

Izno added a subscriber: Izno.Oct 30 2015, 11:32 AM
APerson added a subscriber: APerson.EditedOct 30 2015, 6:42 PM

What I like, now, is that with one click, I can be in the editor of my choice. So it's not clear to me what problem is being solved by a single edit tab.

I couldn't agree more.

There's a big population of users (particularly at wikis where VE is fully enabled) who are used to two edit tabs, and when that expectation is violated, confusion is going to result.

Also agreed.

I don't really see why this needs to happen. Are people complaining that the edit tabs are taking up too much room together or something?

Edit: Apparently there are plans to have a preference users can set to stick with two tabs, so I don't object to this change anymore.

We do get a few complaints about it. The people who want "all wikitext, all the time"—except when they need to delete a column from a table, or don't want to type ouf the citation template, or whatever thing is quicker to do in VisualEditor—seem to have the biggest problem with it. They either have to get used to having two buttons (see: long string of complaints about editors accidentally clicking the wrong one), or they can't use VisualEditor at all (see: most of the people who disabled it because they kept opening VisualEditor by accident).

But if you had a one-button system, then you wouldn't have any UI change to "get used to"; it would all be the same. If you needed to go delete a couple of columns from a table (or whatever), then you could pop over to the visual editor, make that change, and then switch right back to wikitext.

A one-button system also works well for the growing minority of editors who do everything in VisualEditor. VisualEditor is pretty good for content creation (as opposed to, say, certain kinds of gnoming), and there are many people who almost never use wikitext in Wikipedia articles.

Neil_P._Quinn_WMF added a comment.EditedOct 30 2015, 10:48 PM

Another group that would benefit from a single edit tab is potential users, who might start editing if the circumstances are right but can be easily driven away by poor or confusing UX. Having two edit tabs and requiring new users to choose between them without really understanding the choice increases the cognitive burden of starting to edit, when the whole purpose of the visual editor is reducing that burden.

This may not be huge issue on the English Wikipedia right now, because the visual editor has only been offered to registered users. However, it's definitely significant on all the wikis where it's offered to anonymous users (which I expect will eventually include the English Wikipedia).

(As an aside, some might object that if you can't manage the cognitive burden of two edit tabs, you probably can't manage the burden of writing an encyclopedia article. But ability and willingness to figure out a piece of software is not the same as ability and willingness to research and write about an interesting topic. My dad is a doctor who spends his free time reading scientific journals and writing articles about ancient Indian music—but as a kid I spent hours trying to help him figure out how to use Microsoft Word).

The last two comments have identified two specific problems with having two tabs, not one:

  • Users who accidentally click the wrong tab
  • Potential users who aren't sure which edit tab to pick, and therefore might decide to not edit at all

The underlying problem here, I think, is that the two tabs are almost the same. Same font, same coloring, and very similar wording ("Edit" versus "Edit source"). Plus "Edit source" isn't clearly understandable to other than those who do programming ("source code").

Suppose the two tabs were clearly different (font, coloring, whatever), and they read "VisualEditor" and "Wikitext editor". (For example, "Wikitext editor" could be on two lines, and in a smaller font.) Then the chances of clicking on the wrong tab are essentially nil.

One obvious objection: these captions would make it more difficult for people to realize that they an edit Wikipedia. But, in fact, surveys have repeatedly found that the vast majority of readers don't realize that they can edit Wikipedia, despite the "Edit" tab, and for those who do, the vast majority are afraid to do so. Given that, different labeling on the tabs might well be intriguing enough to get more people to click on an editing tab, rather than fewer people.

As far as cognitive burden goes, I'd argue that when the choice is clear - there are two different interfaces - the burden is minimal. What's more important is to minimize the penalty for clicking on a tab, and realizing that it doesn't lead to somewhere you want to be. That's why it's important for pages to load quickly, for editing, and why having a clearly visible "Cancel" option is a good thing. With minimal penalty for clicking in the "wrong" place, possible editors and novice editors aren't going to have a negative impression of Wikipedia's options.

T117281: Create a MOOC about French Wikipedia is blocked by this task on these points:

  • video recording are coming soon and have to know what are next steps concerning the single edit tab to integrate it or not in the video
  • the MOOC introduces VE as primary editor but also introduces wikitext. What will be the way to discover wikitext with the single edit tab?
Alsee added a comment.Nov 2 2015, 12:51 PM

The more I read and the more I think about it, the more it seems that a single edit tab for two editors is just a bad idea. Two editors = two tabs is simple. All the options for merging them are a mess.

In particular I have to agree with He7d3r. I have substantial experience with Flow, "whatever-I-used-last-time" is AWFUL. You don't even need to bother saving the last-used mode for Flow.... you can simplify the code and just call random() mode each time. I wouldn't notice any difference. I constantly have to clean up the mess when it gives me a random mode and craps up my post with with nowikis.

Mvolz awarded a token.Nov 8 2015, 12:51 PM
Risker added a subscriber: Risker.Nov 8 2015, 9:21 PM

There is no benefit to this from the editorial perspective. This is a design change driven by people who do not edit. Please do not implement.

APerson added a comment.EditedNov 8 2015, 11:10 PM

I guess I see why this change would be beneficial (especially to new users), but couldn't there be an option to switch it off somewhere?

I know all about how more preferences introduce more permutations for devs to test as well as a performance hit, so perhaps I'm being selfish here. On the other hand, coding up a gadget to get my two tabs back would be a massive UX pain (because gadgets take a little time to load, so there would be a small delay before the two tabs popped up).

Edit: Apparently this preference (or something like it) is planned, so I don't object to anything here anymore.

There is no benefit to this from the editorial perspective.

This is not true.

This is a design change driven by people who do not edit.

This is not true.

I guess I see why this change would be beneficial (especially to new users), but couldn't there be an option to switch it off somewhere?

Of course, this is part of the system. There's an awful lot of speculation in this thread where people haven't looked at the code (because it doesn't exist yet) and are deciding that instead of asking questions, they will make up a boogeyman and then oppose it.

Given how much this feature has been requested by existing community members over the past few years, I'm disheartened that some have chosen to ignore those requests and make claims about it.

I'm going to repeat most of an earlier comment, because I think it gets to the heart of the issue, and because no one has responded to it:

Two specific problems have been identified as being caused by having two edit tabs, not one:

  • Users who accidentally click the wrong tab
  • Potential users who aren't sure which edit tab to pick, and therefore might decide to not edit at all

The underlying cause of the first problem - the one that existing community members have complained about over the past few years - is that the two tabs are almost the same. Same font, same coloring, and very similar wording ("Edit" versus "Edit source"). Plus "Edit source" isn't clearly understandable to other than those who do programming ("source code").

There is another "solution" besides a single tab: make the two tabs were clearly different : font, coloring, whatever. And change the text so that one says "VisualEditor" and the other says "Wikitext editor". (For example, "Wikitext editor" could be on two lines, and in a smaller font.) Then the chances of clicking on the wrong tab are essentially nil.

As for whether brand new editors would be better off with one tab or two, I can assert that they would not, and proponents of a single tab can assert that they would, but the only real evidence would be from A/B testing. Until (if ever) that takes place, why not make a modest investment of time in changing the two tabs so that they are clearly different, to reduce or eliminate the confusion that is causing editors to complain?

I think a single tab would be better than two, but I also think a preference here would be useful.

  • When editing a page:
    • Remember last editor I used [the default]
    • Always prefer visual editor
    • Always prefer wikitext editor
    • Always ask me
Jdforrester-WMF added a comment.EditedNov 9 2015, 6:38 PM

I think a single tab would be better than two, but I also think a preference here would be useful.

  • When editing a page:
    • Remember last editor I used [the default]
    • Always prefer visual editor
    • Always prefer wikitext editor
    • Always ask me

Yes, that's what is planned, except "ask me" will be "retain having two edit tabs".

I'm going to repeat most of an earlier comment, because I think it gets to the heart of the issue, and because no one has responded to it:

Two specific problems have been identified as being caused by having two edit tabs, not one:

  • Users who accidentally click the wrong tab
  • Potential users who aren't sure which edit tab to pick, and therefore might decide to not edit at all

    The underlying cause of the first problem - the one that existing community members have complained about over the past few years - is that the two tabs are almost the same. Same font, same coloring, and very similar wording ("Edit" versus "Edit source"). Plus "Edit source" isn't clearly understandable to other than those who do programming ("source code").

No. This is profoundly and totally mis-understanding the problem. The problem is not "you can't distinguish the two editors even though they're different", it's "the two editors are different even though they don't need to be".

The objections, quite rightly, are mostly that there is no reason to add yet another control into the already-bloated interface that MediaWiki provides (two edit tabs when editing is a single action). It is grossly disrespectful to readers' and editors' time to add more controls to the interface, and though we felt we had to do it at first, this was always part of the plan since at least 2012.

A secondary point is that we as a community have spent 15 years explaining to people that they need to click 'edit'; having two such things is confusing and undermines the excellent out-reach work people have been doing.

The "people click the wrong tab" (but know the difference between them) idea is not a significant driver of change, because though mildly irritating it isn't a big issue. However, "people click the tab that's wrong for them" (because they don't understand the difference) is an issue.

Quiddity edited the task description. (Show Details)Nov 9 2015, 7:10 PM

Also, all these comments about design, how it should work etc. should be on the task about that, T114530. This is just the overall switch-over task.

Jdforrester-WMF changed the title from "Provide a single edit tab which has both visual and wikitext modes and allows on-the-fly switching between them" to "Migrate wikis to use a single edit tab which has both visual and wikitext modes and allows on-the-fly switching between them".Nov 9 2015, 7:14 PM
Jdforrester-WMF edited the task description. (Show Details)
APerson added a comment.EditedNov 9 2015, 7:51 PM

I think a single tab would be better than two, but I also think a preference here would be useful.

  • When editing a page:
    • Remember last editor I used [the default]
    • Always prefer visual editor
    • Always prefer wikitext editor
    • Always ask me

Yes, that's what is planned, except "ask me" will be "retain having two edit tabs".

Oh, okay then. Sorry I didn't notice this earlier. (Oops.)

I think a single tab would be better than two, but I also think a preference here would be useful.

  • When editing a page:
    • Remember last editor I used [the default]
    • Always prefer visual editor
    • Always prefer wikitext editor
    • Always ask me

Yes, that's what is planned, except "ask me" will be "retain having two edit tabs".

Oh, okay then. Sorry I didn't notice this earlier. (Oops.)

It's my fault, it wasn't documented here and I didn't see people's comments here. Sorry!

RandomDSdevel added a subscriber: RandomDSdevel.EditedNov 9 2015, 10:27 PM

I think a single tab would be better than two, but I also think a preference here would be useful.

  • When editing a page:
    • Remember last editor I used [the default]
    • Always prefer visual editor
    • Always prefer wikitext editor
    • Always ask me

Yes, that's what is planned, except "ask me" will be "retain having two edit tabs".

     I can think of one other way that 'Always ask me' could be implemented that would also allow users to pick between 'retain having two edit tabs' option and the previously proposed 'Display a menu' option that has, as of now, been rejected, while also integrating the 'Remember last editor I used' option. It would have the following options:

  • 'When editing a page' group of radio buttons:
    • 'Always prefer VisualEditor'
    • 'Always prefer wikitext editor'
    • 'Allow access to both editors via…:' (drop-down menu:)
      • '…separate tabs.'
      • '…a drop-down menu.'
    • Checkbox for the 'Remember last editor I used' option (grouped with the drop-down menu's second option somehow since it only makes sense with that.)

The first two options could also be combined into an 'Always prefer…' drop-down menu with options for VisualEditor and the normal wikitext editor if desired. The 'Remember last editor I used' checkbox would either turn the drop-down menu into a combo button of some sort, and I can think of a couple different designs for that:

  • Have the button say something like 'Edit…' and have a drop-down menu indicator caret next to it that expands into a menu containing options for '…with the wikitext editor' and '…with VisualEditor,' the most recently used of which, if remembered, would be indicated with some sort of highlight, icon, or text string (perhaps 'Most recently used editor' or 'You used this editor last time?') Clicking the button would punt you to the editor you last used, and clicking the drop-down arrow would allow to decide whether or not you wanted to override that.
  • Make checking the 'Remember last editor I used' checkbox could move the 'Edit…' label off of the combo button and to the left of it, changing it to say something like 'Edit with:,' allowing the combo button itself to display your most recently used editor and making clicking on that combo button's drop-down arrow overlay the button with a menu containing options for both editors.

Another possible design could be a sub-paned list of available editors, each of which could be enabled or disabled at will, with a radio button next to each option in a 'Default editor' column. Not choosing any editor as a default (that is, deselecting the currently selected 'Default editor' radio button, thereby leaving them all blank) would requiring a user to use either different tabs or a drop-down menu, as specified in a drop-down menu below the sub-pane, to select the editor they want to use each time they want to edit a page, though I don't see that option being used much. The 'Remember last editor I used' checkbox could then also move under the sub-pane, perhaps only being enabled when users don't select a default editor.
     Regardless of whatever design eventually comes into use, explaining to users that an editor can't be used in a namespace should be relatively simple: the relevant tab or menu item could be dimmed, and a tooltip and/or a message upon entering edit mode explaining why the editor they expected can't be used in the namespace in which they are currently located (this latter option would probably be more useful for users who either have a default editor or use the editor they last used, especially if access in this manner were made more prominent.) Also, I agree any changes made to editor access should not interfere with current gadgets (wikEd, in particular, comes to mind, since it replaces the wikitext editor with a more sophisticated one.) Anyway, those are my thoughts concerning possible designs for a new editor-picking interface.

Alsee added a comment.Nov 12 2015, 8:12 PM

For wikis where VE isn't the default choice, on an IP's edit-click, set a cookie of a random number, and allow direction to WE or VE based on some threshold (so ramped-up change is possible) – X
For such wikis, slowly increase the switchover with testing to ensure it's not disruptive – X.

Jdforrester-WMF, could you please clarify? It's very possible I'm misreading this, but it sounds like you just declared an unconditional force over of all wikis to a VE-default as part of the single-edit-tab project.

Jdforrester-WMF added a comment.EditedNov 12 2015, 8:26 PM

For wikis where VE isn't the default choice, on an IP's edit-click, set a cookie of a random number, and allow direction to WE or VE based on some threshold (so ramped-up change is possible) – X
For such wikis, slowly increase the switchover with testing to ensure it's not disruptive – X.

Jdforrester-WMF, could you please clarify? It's very possible I'm misreading this, but it sounds like you just declared an unconditional force over of all wikis to a VE-default as part of the single-edit-tab project.

Yes, you're mis-reading. This is how we would do the much-asked-for A/B test for anonymous users about which editor we prompt them with, which has been requested from (amongst other wikis) the English Wikipedia for several years now. Obviously we're not going to just do it without talking to the wikis first. :-)

Alsee added a comment.Nov 12 2015, 8:47 PM

Thanx. Sorry for getting paranoid, chuckle.

Thanx. Sorry for getting paranoid, chuckle.

No worries. :-)

Hi. Splitting and redirecting feedback channels is not nice. Let's keep the discussion in one task.

Hi. Splitting and redirecting feedback channels is not nice. Let's keep the discussion in one task.

I agree, it'd be nice if feedback continued to be at the open-since-2013 community-requested task.

Base awarded a token.Jan 9 2016, 5:48 AM
Vogone added a subscriber: Vogone.Jan 9 2016, 5:52 AM

I have a question concerning the user preferences. If I choose to use the old wikitext editor as my personal default editor, do I need to switch from VE to WT manually and individually on every wiki and every device I use or will there be an easy way to make this decision with global effect? This is quite important to me, because as a globally active user I edit several hundred different wikis and my slow internet connection does not appreciate VisualEditor at all.

Ess added a subscriber: Ess.Jan 9 2016, 6:53 AM

Visual Editor is not a good editing UI. It's highly confusing, hard to navigate, extremely heavyweight and is full of bugs. None of the Russian editing gadgets work with it, and those gadgets are essential for productivity. I therefore strongly oppose merging the tabs for the old-style editor and VE, as the latter is clearly not yet ready for production.

DC awarded a token.Jan 9 2016, 7:34 PM

I have a question concerning the user preferences. If I choose to use the old wikitext editor as my personal default editor, do I need to switch from VE to WT manually and individually on every wiki and every device I use or will there be an easy way to make this decision with global effect? This is quite important to me, because as a globally active user I edit several hundred different wikis and my slow internet connection does not appreciate VisualEditor at all.

Hey @Vogone. Unfortunately, because every wiki is configured individually per community request, we can't have a single setting that applies to all wikis. In your case I'd recommend using a script to mass-set your preferences the way you like them.

Qgil mentioned this in Unknown Object (Task).Feb 2 2016, 1:53 PM
Krinkle removed a subscriber: Krinkle.Mar 8 2016, 10:14 PM
Alsee added a comment.EditedApr 3 2016, 5:07 PM

@Jdforrester-WMF
I earlier asked if the WMF was going to try to push a VE-default as part of the single-edit-tab deployment. You said you wouldn't do that without talking to the wikis first.

I am rather dismayed to see that VE was defined as the "primary" editor on Polish wiki, with apparently zero community discussion. I am even more dismayed to hear that the WMF has apparently defined "VE-primary" for ALL wikis except EnWiki.

I went to Polish Wiki to see how single-edit-tab works. I created a new account, I clicked edit. My browser froze up waiting for VE to load, because the default VE-primary editor is made to load first. After VE eventually finishes loading, a new user is then given a menu which directs them into the VE-default if they click to "continue" editing. In order to get the wikitext editor they have to click a confusing "Switch" to trigger a load of the "secondary" editor. Then it gets even worse. I closed the tab without making any selection. When I opened a new tab and clicked edit, I was shoved directly into VE-default.

Is it the WMF position that VE will be slipped in as default editor as part of single-edit-tab deployment, without discussion, for all wikis except EnWiki?

I could be mistaken, but I suspect most wikis consider the wikitext editor to be the primary editor.

At first I hoped that it would have been possible to stick with the 'double edit tab', or at least that the 'single edit tab' would have made easier to get rid of VisualEditor, but I actually had a very similar experience to @Alsee's. Forcing users into trying an editor at the cost of disrupting the flow, no matter how good the editor may be, is harmful.

@Ricordisamoa, based on the information we have, very few editors are choosing to have two tabs. For example, here are the numbers from the Polish Wikipedia, after they had been in Single Edit Tab mode for about two weeks. There are 4,000 active editors there each month (at least one edit).

  • Only 300 of them chose to have two tabs.
  • About 800 had chosen to have one tab that always opens their favorite editing environment (usually the wikitext editor).
  • Everyone else (an unknowable number, but probably on the order of 2,000 logged-in editors) stayed with the default (one tab that leads to whatever editor you opened last – which is the wikitext editor for more than half of highly experienced editors).

This is a "round numbers" estimate, but the dual-tab system, despite being my own personal preference, seems to be chosen by only about 10% of editors there.

I would be interested in hearing from any communities that expect to see significantly more editors choosing the dual-tab system. (I asked people at the English Wikipdia to tell me what preference they expected to choose, but nobody answered that part of my question.)

Polish Wikipedia, anonymous user, cookies & storage disabled, any article, click Edytuj. VisualEditor seems to be loading, but the progress bar stops at the end. I cannot edit any part of the page. And because VE hijacks URLs, I can't even get to the wikitext editor by appending "?action=edit" to the address. I must disable JavaScript to edit. That is INTOLERABLE (bold, all caps).

Whenever the system is unable to set temporary preferences, it should display both tabs or at least give users the ability to choose the editor every time. And that must happen without having the whole VisualEditor load first.

ThurnerRupert added a comment.EditedApr 17 2016, 12:07 PM

i really do not understand why you guys keep fighting for having visual editor as only option for years. just show both tabs, and let the users switch off one of them in the rare case a user really has a strong preference.